// OPN2001_DEMODlg.h : header file
//

#pragma once

#include <list>
#include "afxwin.h"


typedef struct 
{
	LPCWSTR szSymbolName;
	long	lSymbol;
}SBCD_DEFS;




// COPN2001_DEMODlg dialog
class COPN2001_DEMODlg : public CDialog
{
// Construction
public:
	COPN2001_DEMODlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_OPN2001_DEMO_DIALOG };

	static void *pDlgObject;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

private:
	std::list<int> m_nPortArray;
	std::list<int>::iterator m_itPorts;
	
	int m_nUsedPort;

// Implementation
protected:
	HICON m_hIcon;
	CString m_strConfigFile;	// holds the previously used serial port
	BOOL	m_bSaveToFile;
	CString m_strSaveFile;
	BOOL	m_bAuto;
	BOOL	m_bAutoNotClicked;
	BOOL	m_bShowAll;
	BOOL	m_bComOpen;

	virtual void OnOK();
	virtual void OnCancel();
	BOOL StartAutomaticDownload( void );
	BOOL StopAutomaticDownload( void );
	void ConvertBarcodeToString( char *szBarcode, CString &strTemp, long lAsciiMode, long lRTC );
	void InitFormatControls();
	void COPN2001_DEMODlg::ManipulateTimeStamp(CString& tmpRTC, CString& hour, CString& minute, CString& second, CString& ampm, CString& day, CString& month, CString& year);

	void ShowErrorMessage( long lErrorCode );
	void InitComboBox();
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	static int __stdcall csp2PollCallback( void );
	int HandlePollCallback( void );

	CComboBox m_cmboPort;
	afx_msg void OnCbnSelchangeCmboPort();
	afx_msg void OnBnClickedBtnOpen();
	afx_msg void OnBnClickedBtnClose();
	CButton m_btnOpen;
	CButton m_btnClose;
	afx_msg void OnBnClickedBtnInterrogate();
	CStatic m_statDllVersion;
	CStatic m_statOSVersion;
	CStatic m_statID;
	LRESULT OnDeviceChange( WPARAM wParam, LPARAM lParam );
	afx_msg void OnBnClickedBtnGetTime();
	afx_msg void OnBnClickedBtnSetTime();
	afx_msg void OnBnClickedCheckAuto();
	CButton m_btnAuto;
	CListBox m_listBcdData;
	afx_msg void OnBnClickedBtnGetBarcode();
	afx_msg void OnBnClickedBtnClearBarcode();
	afx_msg void OnBnClickedBtnParameters();
	afx_msg void OnBnClickedCheckSave();
	afx_msg void OnClose();
	afx_msg void OnBnClickedBtnAbout();
	afx_msg void OnBnClickedCheckSymbology();
	afx_msg void OnBnClickedCheckTime();
	afx_msg void OnBnClickedCheckDate();
	afx_msg void OnBnClickedRadioFormatText();
	afx_msg void OnBnClickedRadioFormatCSV();
	afx_msg void OnBnClickedRadioTime12();
	afx_msg void OnBnClickedRadioTime24();
	afx_msg void OnBnClickedRadioDateUSA();
	afx_msg void OnBnClickedRadioDateEU();
	afx_msg void OnBnClickedRadioDateLong();
	afx_msg void OnCbnSelChangeComboDelimeter();
	
	//Text Formatting Controls
	CButton m_checkSymbology;
	CButton m_checkTime;
	CButton m_checkDate;
	CButton m_radioText;
	CButton m_radioCSV;
	CComboBox m_cmboDelimeter;
	CButton m_radiot12;
	CButton m_radiot24;
	CButton m_radiodUSA;
	CButton m_radiodEU;
	CButton m_radiodLong;
	//End Text Formatting Controls
//	afx_msg void OnCbnEditUpdateComboDelimeter();
	afx_msg void OnBnClickedBtnBrowse();
	afx_msg void OnBnClickedShowAll();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};

